#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include "throttle.h"
#include <sys/stat.h>
#include <utmp.h>
#include <fcntl.h>
#include "h.h"
#ifdef FLUD
#include "blalloc.h"
#endif /* FLUD */

#if defined( HAVE_STRING_H)
#include <string.h>
#else
#include <strings.h>
#endif

/* Codes suivants pour les v1.0.*
* par Jib
*/

/* (d)verrouillage serveur */

int m_lock(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
FILE *fp;
if (!IsAnOper(sptr))
    {
    sendto_one(sptr,err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
    }
else
    {
   	sendto_realops("%s is locking server", parv[0]);
    sendto_gnotice("To prevent %s's security, the server is temporary locked. You can chat but new connections are forbidden", NOM);
	fp = fopen("db/limite.db", "w");
	fprintf (fp, "1");
	fclose(fp);
	return 0;
    }
}

int m_unlock(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
FILE *fp;
    if (!IsAnOper(sptr))
    {
    sendto_one(sptr,err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
    }
else
    {
   	sendto_realops("%s is opening server", parv[0]);
    sendto_gnotice("%s is opened, accepting connections...", NOM);
	fp = fopen("db/limite.db", "w");
	fprintf (fp, "0");
	fclose(fp);
	return 0;
	}
}

/* commande de vhost */

int m_sethost(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
    if ((!IsAnOper(sptr))&&(!IsHelper(sptr)))
    {
    sendto_one(sptr,err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
    }
else
    {
    if (parc < 2)
    {
    sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Syntax : /sethost <host>", me.name, parv[0]);
    return 0;
    }
    else
    {
    sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Your host (%s@%s) has changed for %s ", me.name, parv[0], sptr->username, sptr->user->host, parv[1]);
   	sendto_realops("%s has changed his host (%s@%s) for %s", parv[0], sptr->username, sptr->user->host, parv[1]);
		    strncpyzt(sptr->user->host, parv[1], HOSTLEN + 1);
		    strncpy(sptr->sockhost, parv[1], HOSTLEN + 1);
    return 0;
    }
	}
}

/* commande de vident */

int m_setident(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
char *tmphost;
tmphost = sptr->sockhost;
    if (!IsAnOper(sptr))
    {
    sendto_one(sptr,err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
    }
else
    {
    if (parc < 2)
    {
    sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Syntax : /setident <ident>", me.name, parv[0]);
    return 0;
    }
    else
    {
   	sendto_realops("%s has changed his ident (%s) for %s", parv[0], sptr->user->username, parv[1]);
		    strncpyzt(sptr->user->username, parv[1], HOSTLEN + 1);
		    strncpyzt(sptr->user->host, tmphost, HOSTLEN + 1);
		    strncpy(sptr->sockhost, tmphost, HOSTLEN + 1);

    return 0;
    }
	}
}

/* Commande d'ajout de ligne dans l'ircd.conf */

int m_addline(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
FILE *fp;
    if (!IsAdmin(sptr))
    {
    sendto_one(sptr,err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
    }
else
    {
    if (parc < 2)
    {
    sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Syntax : /addline <line>", me.name, parv[0]);
    return 0;
    }
    else
    {
   	sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Line added into the config file...", me.name, parv[0]);
   	sendto_realops("%s used the addline command", parv[0]);
	fp = fopen("ircd.conf", "a");
	fprintf (fp, "\n");
	fprintf (fp, "#Line added by %s :\n", parv[0]);
	fprintf (fp, "%s\n", parv[1]);
	fclose(fp);
	return 0;

    return 0;
    }
	}
}

/* Codes pour les v1.1 et 1.2
*/

/* Commande addhelper <login> <pass>
* par Jib
* 21/09/2002
*/

int m_addhelper(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
char nouvohelper[50];
FILE *fp;
    if (!IsAdmin(sptr))
    {
    sendto_one(sptr,err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
    return 0;
    }
else
    {
    if (parc < 3)
    {
    sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Syntax : /addhelper <login> <pass>", me.name, parv[0]);
    return 0;
    }
    else
    {
    strcpy(nouvohelper, "\n");
    strcat(nouvohelper, "O:*@*:");
    strcat(nouvohelper, parv[2]);
    strcat(nouvohelper, ":");
    strcat(nouvohelper, parv[1]);
    strcat(nouvohelper, ":H:1\n");
  	sendto_realops("%s used the addhelper command...", parv[0]);
    fp = fopen("ircd.conf","a");
	fprintf (fp, "%s", nouvohelper);
	fclose(fp);
	return 0;
    }
    }
}

/* Commande chghost <nick> <host>
* par Jib
* 26/10/2002
*/

int  m_chghost(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	aClient *acptr;
	if (MyClient(sptr) && !IsAdmin(sptr))
	{
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name,
		    parv[0]);
		return 0;
	}

	if (parc < 3)
	{
		sendto_one(sptr,
		    ":%s NOTICE %s :*** ChgHost Error: Syntax is /chghost <nick> <newhost>",
		    me.name, sptr->name);
		return 0;
	}

	if (strlen(parv[2]) < 1)
	{
		sendto_one(sptr,
		    ":%s NOTICE %s :*** ChgHost Error: The host cannot be NULL.",
		    me.name, sptr->name);
		return 0;
	}

	if (strlen(parv[2]) > (HOSTLEN))
	{
		sendto_one(sptr,
		    ":%s NOTICE %s :*** ChgHost Error: Hostnames are limited to %i characters.",
		    me.name, sptr->name, HOSTLEN);
		return 0;
	}

	if ((acptr = find_person(parv[1], NULL)))
	{
        sendto_serv_butone(cptr, ":%s CHGHOST %s %s", parv[0], parv[1], parv[2]);
	strncpy(acptr->user->host, parv[2], HOSTLEN + 1);
	strncpy(acptr->sockhost, parv[2], HOSTLEN + 1);
		return 0;
	}
	else
	{
		sendto_one(sptr, err_str(ERR_NOSUCHNICK), me.name, sptr->name,
		    parv[1]);
		return 0;
	}
	return 0;
}



/* commande /sajoin <nick> <canal>
 * ajoute le 14/12/2002
 * utile pour le sajoin des ircop  l'oper
*/

int	m_sajoin(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int	parc;
char	*parv[];
{
	aClient	*acptr;

	if (parc!=3 || !(acptr = find_person(parv[1], NULL)))
		return 0;

if (IsServer(sptr))
{
	if(MyClient(acptr)) {
		parv [0] = parv [1];
		parv [1] = parv [2];
		 (void)m_join(acptr,acptr,2,parv);
	}
	else
	sendto_serv_butone(cptr, ":%s SAJOIN %s %s", parv[0],
			parv[1], parv[2]);
}
	return 0;
}

/* commande /sapart <nick> <canal>
 * ajoute le 09/07/2003         
 * utile pour le sajoin des ircop  l'oper
*/

int     m_sapart(cptr, sptr, parc, parv)
aClient *cptr, *sptr;
int     parc;
char    *parv[];
{        
        aClient *acptr;

        if (parc!=3 || !(acptr = find_person(parv[1], NULL)))    
                return 0;

if ((IsSAdmin(sptr))||(IsAdmin(sptr)))
{    
        if(MyClient(acptr)) {
                parv [0] = parv [1];
                parv [1] = parv [2];    
                 (void)m_part(acptr,acptr,2,parv);
        }          
        else     
        sendto_serv_butone(cptr, ":%s SAPART %s %s", parv[0],
                        parv[1], parv[2]);
}
        return 0;
}
