#!/bin/sh
spitshell=cat
package=IRC

echo "Extracting $package/src/version.c..."

if test -r version.c.last
then
	generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
if test ! "$generation" ; then generation=0; fi
else
	generation=0
fi

generation=`expr $generation + 1`

uname=`uname -a`

creation=`date | \
awk '{if (NF == 6) \
{ print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
{ print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!

#include "struct.h"
#include "patchlevel.h"

char *generation = "$generation";
char *creation = "$creation";
char version[128];

char *infotext[] =
    {
	 "$package --",
	 "Based on the original code written by Jarkko Oikarinen",
	 "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
	 "",
	 "This program is free software; you can redistribute it and/or",
	 "modify it under the terms of the GNU General Public License as",
	 "published by the Free Software Foundation; either version 1, or",
	 "(at your option) any later version.",
	 "",
	 "Send bug reports bugs@andromede.net",
	 "",
	 "",
	 "The following people have contributed code, support, or testing ",
	 "to the Andromede team:",
	 "Jib                Jrmie Bnitez     jibsworld@andromede.net",
	 "nico               Nicolas Michel      nico@andromede.net",
         "",
         "Please visit our website http://www.andromede.net",
         "",
	 "Thanks to sim0n for his quality hosting http://www.binary-pulse.org",
	 "",
    "",
	 0,
};
!SUB!THIS!
